
Ruby - Bug #19409

Object's shape is reset after a ractor move

02/03/2023 07:10 PM - luke-gru (Luke Gruber)

Status: Closed   

Priority: Normal   

Assignee: ko1 (Koichi Sasada)   

Target version:    

ruby -v:  Backport: 2.7: UNKNOWN, 3.0: UNKNOWN, 3.1:

UNKNOWN, 3.2: UNKNOWN

Description

I believe an object should have the same shape after being moved from 1 ractor to another.

class Obj

  attr_accessor :a, :b, :c, :d

  def initialize

    @a = 1

    @b = 2

    @c = 3

  end

end

r = Ractor.new do

  obj = receive

  #p RubyVM::Shape.of(obj)

  obj.d = 4

  p obj.a, obj.b, obj.c, obj.d # gets wrong values due to object shape id being reset on object

end

obj = Obj.new

#p RubyVM::Shape.of(obj)

r.send(obj, move: true)

r.take

Associated revisions

Revision 32c4b0125f9afe11909d1c10e4133e20180e809e - 01/01/2024 11:10 PM - luke-gru (Luke Gruber)

Set Ractor moved object's shape to original object's shape

Fixes [Bug #19409]

Revision 32c4b0125f9afe11909d1c10e4133e20180e809e - 01/01/2024 11:10 PM - luke-gru (Luke Gruber)

Set Ractor moved object's shape to original object's shape

Fixes [Bug #19409]

Revision 32c4b012 - 01/01/2024 11:10 PM - luke-gru (Luke Gruber)

Set Ractor moved object's shape to original object's shape

Fixes [Bug #19409]

History

#1 - 02/07/2023 06:03 AM - hsbt (Hiroshi SHIBATA)

- Status changed from Open to Assigned

- Assignee set to ko1 (Koichi Sasada)

#2 - 01/04/2024 10:30 PM - luke-gru (Luke Gruber)

This has been fixed by https://github.com/ruby/ruby/commit/32c4b0125f9afe11909d1c10e4133e20180e809e, please close. Thanks!

#3 - 01/04/2024 11:44 PM - jeremyevans0 (Jeremy Evans)

- Status changed from Assigned to Closed
